//display UI

boolean extraHeart=false;
class UI {
  GameWorld gameWorld;
  UI(GameWorld _gameWorld) {
    this.gameWorld=_gameWorld;
  }

  void draw() {
    displayLives();
    displayScore();
    displayRainbowMeter();
    image(pressPause, gameWorld.worldWidthMeters-1.4, -0.05, 0.45, 0.3);
  }


  //display Lives
  void displayLives() {
    float size=0.2;
    imageMode(CENTER);
    if (gameWorld.lives>=1) {
      image(lives[8], gameWorld.worldWidthMeters/2-(size+0.05), 0.1, size, size);
    }
    if (gameWorld.lives>=2) {
      image(lives[8], gameWorld.worldWidthMeters/2, 0.1, size, size);
    }
    if (gameWorld.lives>=3) {
      image(lives[8], gameWorld.worldWidthMeters/2+(size+0.05), 0.1, size, size);
    }
    imageMode(CORNER);

    image(lives[gameWorld.bubbleScore], 0.1, 0.1, size+0.2, size+0.2);
    if (gameWorld.bubbleScore>=7) {
      extraHeart=true;
      //gameWorld.bubbleScore=0;
    }
  }

  void displayScore() {
    float size=0.2;
    //calculate number positions (x,y)
    int onesPlace=(gameWorld.gameHeight%10)/1;
    int tensPlace=(gameWorld.gameHeight%100-onesPlace)/10;
    int hundredsPlace=(gameWorld.gameHeight%1000-onesPlace-tensPlace)/100;
    int thousandsPlace=(gameWorld.gameHeight%10000-onesPlace-tensPlace-hundredsPlace)/1000;
    int tenThousandsPlace=(gameWorld.gameHeight%100000-onesPlace-tensPlace-hundredsPlace-thousandsPlace)/10000;
    float x1=gameWorld.worldWidthMeters-((size-0.07)*2);
    float x2=gameWorld.worldWidthMeters-((size-0.07)*3);
    float x3=gameWorld.worldWidthMeters-((size-0.07)*4);
    float x4=gameWorld.worldWidthMeters-((size-0.07)*5);
    float x5=gameWorld.worldWidthMeters-((size-0.07)*6);
    float xm=gameWorld.worldWidthMeters-(size-0.10);
    float y=size-0.05;
    //draw numbers
    imageMode(CENTER);


    if (gameWorld.gameHeight<10) {
      image(heightBackground, xm, y, size*2, size+0.1);
      image(numbers[onesPlace], x1, y, size, size);
    }
    if (gameWorld.gameHeight<100&&gameWorld.gameHeight>=10) { 
      image(heightBackground, xm, y, size*4, size+0.1);
      image(numbers[onesPlace], x1, y, size, size);
      image(numbers[tensPlace], x2, y, size, size);
    }
    if (gameWorld.gameHeight<1000&&gameWorld.gameHeight>=100) { 
      image(heightBackground, xm, y, size*6, size+0.1);
      image(numbers[onesPlace], x1, y, size, size);
      image(numbers[tensPlace], x2, y, size, size);
      image(numbers[hundredsPlace], x3, y, size, size);
    }
    if (gameWorld.gameHeight<10000&&gameWorld.gameHeight>=1000) { 
      image(heightBackground, xm, y, size*8, size+0.1);
      image(numbers[onesPlace], x1, y, size, size);
      image(numbers[tensPlace], x2, y, size, size);
      image(numbers[hundredsPlace], x3, y, size, size);
      image(numbers[thousandsPlace], x4, y, size, size);
    }
    if (gameWorld.gameHeight<100000&&gameWorld.gameHeight>=10000) { 
      image(heightBackground, xm, y, size*10, size+0.1);
      image(numbers[onesPlace], x1, y, size, size);
      image(numbers[tensPlace], x2, y, size, size);
      image(numbers[hundredsPlace], x3, y, size, size);
      image(numbers[thousandsPlace], x4, y, size, size);
      image(numbers[tenThousandsPlace], x5, y, size, size);
    }
    image(letters[6], xm, y, size, size);
    imageMode(CORNER);
  }


  //display the rainbowMeter
  int animationCounter=0;

  void displayRainbowMeter() {
    float x=gameWorld.worldWidthMeters-0.2;
    float y=gameWorld.worldHeightMeters/2;
    int rainbowModeLength=12000; //length in millisec
    float size=1;
    float numberX=gameWorld.worldWidthMeters/2.0;
    float numberY=gameWorld.worldHeightMeters/2.0;


    imageMode(CENTER);

    if (gameWorld.glitterScore>=gameWorld.maxGlitterScore) { //is rainbowMeter full?
      //pulse rainbow Meter if it is full but not used
      if (gameWorld.pulseCounter==0&&gameWorld.rainbowMode==false) {
        rainbowMeterDing.play();//AUDIO
      }
      gameWorld.pulseCounter++;
      if (gameWorld.pulseCounter<=60&&gameWorld.pulseCounter>40) {
        tint(255, 100);
        image(rainbowMeter[5], x, y, 1, gameWorld.worldHeightMeters/2);
        noTint();
        if (gameWorld.pulseCounter>=60) {
          gameWorld.pulseCounter=0;
        }
      } else
        if (gameWorld.pulseCounter<=40) {
          image(rainbowMeter[5], x, y, 1, gameWorld.worldHeightMeters/2);
        }
      //image(rainbowMeter[5], x, y, 1, gameWorld.worldHeightMeters/2);


      if (gameWorld.rainbowMode==false) {
        if (gameWorld.keys[32]) {    //check if space is pressed to activate rainbowMode
          gameWorld.setRainbowModeTrue();//activates rainbow Mode
        }
      } else if (gameWorld.rainbowMode==true) {
        animationCounter=animationCounter+20;
        if (animationCounter>850) {
          animationCounter=0;
        }

        image(rainbowMeterMode[animationCounter/100], x, y, 1, gameWorld.worldHeightMeters/2);


        float timeRainbowModeIsOn=millis()-(gameWorld.rainbowTime+gameWorld.gamePausedTime);//calculates time RainbowMode is already activate
        //println(millis()-(rainbowTime+gameWorld.gamePausedTime));//debug
        //counts down 3 sec before rainbow Mode stops
        if (timeRainbowModeIsOn>rainbowModeLength-3000&&timeRainbowModeIsOn<rainbowModeLength-2000) {
          image(numbers[3], numberX, numberY, size, size);
        }
        if (timeRainbowModeIsOn>rainbowModeLength-2000&&timeRainbowModeIsOn<rainbowModeLength-1000) {
          image(numbers[2], numberX, numberY, size, size);
        }
        if (timeRainbowModeIsOn>rainbowModeLength-1000&&timeRainbowModeIsOn<rainbowModeLength) {
          image(numbers[1], numberX, numberY, size, size);
        }
        if (timeRainbowModeIsOn>=rainbowModeLength) {//deactivate rainbowMode after 12sec
          gameWorld.setRainbowModeFalse();
        }
      }
    } else {
      //draw rainbowMeter halffull
      switch(gameWorld.glitterScore) {
      case 0:
        image(rainbowMeter[0], x, y, 1, gameWorld.worldHeightMeters/2);
        break;
      case 1:
        image(rainbowMeter[1], x, y, 1, gameWorld.worldHeightMeters/2);
        break;
      case 2:
        image(rainbowMeter[2], x, y, 1, gameWorld.worldHeightMeters/2);
        break;
      case 3:
        image(rainbowMeter[3], x, y, 1, gameWorld.worldHeightMeters/2);
        break;
      case 4:
        image(rainbowMeter[4], x, y, 1, gameWorld.worldHeightMeters/2);
        break;
      }
    }

    imageMode(CORNER);
  }
}
